//
// Blank screensaver
// -------------------
// (c) 1996 Lucian Wischik
// portions (c) 1992-1995 Microsoft Corporation
//
// There is nothing special about this screensaver.
// Note that the timer is created in WM_CREATE, and destroyed in
// WM_DESTROY.
// The response to WM_ERASBKGND is just there for the hell of it


#define WIN32_LEAN_AND_MEAN
#define STRICT
#include <windows.h>
#pragma hdrstop

#include "../../lib/scrplus.h"


LRESULT CALLBACK MyScreenSaverProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{ // This copied out of the Win32 online help
  static HDC          hdc;    /* device-context handle */
  static RECT         rc;     /* RECT structure */
  static UINT         uTimer; /* timer identifier */
  static int          i;      /* colour */
  switch (msg) {
    case (WM_CREATE):
      { uTimer=SetTimer(hwnd,1,200,NULL);
        i=0;
      } break;
    case (WM_ERASEBKGND):
      { hdc=GetDC(hwnd); GetClientRect(hwnd,&rc);
        FillRect(hdc,&rc,(HBRUSH)GetStockObject(i)); ReleaseDC(hwnd,hdc);
      } break;
    case (WM_TIMER):
		{ i++; if (i>4) i=0;
        InvalidateRect(hwnd,NULL,TRUE);
      } break;
    case (WM_DESTROY):
		{ if (uTimer) KillTimer(hwnd,uTimer);
      } break;
  }
  return DefScreenSaverProc(hwnd,msg,wParam,lParam);
}



int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE,LPSTR,int)
{ return ScrExecute(hInstance,MyScreenSaverProc);
}



