// IMPORTANT NOTE!
// This is a pre-release version of the 'bits' library.
// IT DOESN'T WORK POPERLY YET!
// In particular, I haven't been able to get multiple DirectDraw
// surfaces working properly. It always turns out with me that
// all surfaces inside a given DirectDraw object always point to the same
// single surface, and flipping doesn't really mean much.
// If anyone can tell me why this is, please email me! (ljw1004@cam.ac.uk)
// (I'm really trying to get a triple-buffered surface).
//
//
// Bits v0.91
// ------------
// (c) 1996 Lucian Wischik
//
// Bits has two purposes:
//  1. canonical demonstration of palettes and DIBsections;
//  2. make it easier to work in parallel with DirectDraw and DIBSections
//     (primarily for screensavers)
//
// BitsInit, BitsClose:
//   you should call BitsInit at the start of this instance, and BitsClose
//   at the end. I put them at the start and end of my WinMain.
//   They just ensure that all data structures are initialised and tidied
//   Note that DDraw is not loaded until the last minute. This means that
//   if your screensaver does previews with DIBsections, then it doesn't
//   waste time loading DDraw.
//
// BitsQueryDD:
//   Loads DDraw if necessary, and fills out the data structures
//   DDDriverCaps, DDHelCaps, DDNumModes and DDModes (and array of DDSCAPS).
//   Note that it only lists the modes that can be achieved without drastic
//   things like exclusive full-screen.
//
// The bulk of the work goes in two classes:
//   TBits,
//   TBitsSurface.
// Effectively, we're trying to get DIBSections and DDX to be programatically
// the same. This means that things like multiple-surfaces are simulated
// within DIB, and that things like palettes are unified.
// (It only supports 8bpp at the moment).
// TBits is equivalent to a IDirectDraw. (And there's no limit on the
// number of TBits-DIBs that you can have in existence at a time. I don't
// know about IDirectDraws). Palettes and size information is associated
// with the TBits.
// TBitsSurface represents a surface: either an IDirectDrawSurface, or
// a DIBSection.
// TBitsPainter is for DIBs: if you leave painting of your window up to
// TBits, then the TBitsPainter will draw the DIBSection wherever you
// direct it.
//
// TBits
// -------
//   The constructor does nothing. It just makes the object sit there.
//   You start its active life with TBits::Createxxxx(..), and end it with
//   TBits::Reset().
//   But before you create something, you might like to set up preferences:
// TBits::EnableSubClass(BOOL autopaint,HBRUSH hbrBackground)
// TBits::EnableFullSubclass(BOOL flip);
// TBits::DisableSubclass()
//   Subclassing is when the simple act of doing a TBits::Create will,
//   if it happens to be destined for DIBSections, automatically subclass
//   your window to handle all the palette and painting &c.
//   'autopaint' is TRUE or FALSE for whether you want it to subclass painting.
//   If you do not, then you can still call its TBits::Paint(HDC,PAINSTRUCT &)
//   from within your own paint response.
//   If hbrBackground is set, then WM_ERASEBKGND will be subclassed to
//   draw in this colour.
//   Full-subclassing enlarges the window to full-screen and, by default,
//   sets the dibpainter to stretch the image to full-screen. If you
//   turn on flip, then the overall effect will be an exact emulation
//   of DirectDraw: so you can use this to test how it will look.
//   DisableSubclass is the default, and you don't actually need to call it.
// TBits.DibPainter::DontPaint()
// TBits.DibPainter::StretchToWindow()
// TBits.DibPainter::CenterInWindow()
// TBits.DibPainter::CenterAtPoint(POINT &)
// TBits.DibPainter::PositionAtPoint(POINT &)
// TBits.DibPainter::PositionInRect(RECT &)
//   If you let TBits do your painting for you, this is how it will do it.
//   All of the options are obvious.
//
//   Now you can create a TBits.
// TBits::Create(HWND,useddx,NumSurfaces,cx,cy,bpp,usefulpal);
// TBits::CreateCompatible(HWND,useddx,compatible-bits,usefulpal);
// TBits::CreateSingleDibCopy(HWND,copyfrom-surface,usefulpal)
// TBits::CreateSingleDibStretch(HWND,copyfrom-surface,cx,cy)
// TBits::CreateSingleDibFromScreen(HWND,cx,cy)
//   If you pass a NULL hwnd, then the TBits will just exist and
//   not have any displayed part at all. You'd do this if you wanted
//   just to create temporary bitmaps.
//   UseFulPal applies to DIBs: if checked, then any changes you make to
//   the system static colours (0-9, 245-255) will be ignored. This
//   helps ensure that Windows looks good.
//   Often you'd do something like CreateSingleDibFromScreen()
//   to get the screen, and then you could do TBitsSurface::CopyBitsFrom
//   to copy the screen into several different surfaces of your main
//   DirectDraw thingy.
//
// TBits::GetSurface(int surface)
// TBits::LockSurface(int surface)
// TBits::UnlockSurface(TBitsSurface *bs)
//   Used to gain access to the surfaces. See TBitsSurface for more details.
//   Note that these Lock and Unlock are simply for convenience: you could
//   equally well use TBitsSurface::Lock & Unlock.
//   If you're using DirectX then, as far as I can tell, it's impossible
//   to lock surface 0.
//
// TBits::Flip()
//   Surface 1 becomes displayed as surface 0, and they all cycle around.
//   If you use DIBs then you're allowed just one surface; if you want
//   to use DDX, then you probably won't be able to write to surface 0 so
//   it wouldn't make sense having less than 2 surfaces.
//
// TBits::ChangePalette(BOOL lazy=TRUE)
//   First, set up your new palette in LogPal.Entries[]. Then call this function.
//   If lazy is set to TRUE, then a DIB will not redraw itself until you
//   call Flip at some later date. I don't know how DDX behaves in this
//   respect for changing palettes.
//
// TBits::bpp, cx, cy, numbytes, numdwords, orientation, NumSurfaces
//   All are just informational fields. orientation is 1 if pixel zero is
//   at the top left, and -1 if it is at the bottom left.
//
// TBits::TakeFullPalette(), RelinquishFullPalette()
//   These are used by the DIB things, on creating and resetting and
//   activate-apping, to snitch all of the system static colours if you
//   expressed that wish, or to leave them all alone. You might want
//   to call them if you're doing stuff manually.
// TBits::WmActivateApp(), WmPaint(), Paint(), WmPaletteChanged(),
// WmQueryNewPalette(), WmEraseBkgnd()
//   All of these are available for you to call if you want to. If you
//   had turned on autosubclassing, then they'll be called automatically.
//
//
// TBitsSurface
// --------------
//   You'll never create or destroy these yourself. That is done automatically
//   when you create a TBits. A TBitsSurface represents the raw pixels.
//
// TBitsSurface::Lock(), TBitsSurface::Unlock()
//   You must lock before and lock after any access. (Although doing this
//   isn't really necessary for DIBSections, it has still been enforced
//   for them so that it's easier for you to write your code for DIB
//   and then convert it to DDX, confident in the knowledge that it will
//   still work.
// TBitsSurface::data.lpb, .lpdw, .lpv
//   Different types for the same thing. (pointer-to-byte, pointer-to-dword,
//   pointer-to-void). This is the pointer to the start of the surface.
//   It is only valid while the surface is locked.
//
// TBitsSurface::bits
//   This points to the TBits object to which this surface belongs. It makes
//   it easier to refer to things like cx, cy, numbytes, numlongs, bpp.
//
// TBitsSurface::CopyBitsFrom(other-surface)
//   This copies the entire other surface over to this one, clipping if
//   it is larger, padding out with black if it is smaller.
//   If either this surface or the other one are not locked, then CopyBitsFrom
//   will lock them. (and unlock them afterwards).
//   Be careful! If you accidentally tried to copy from or to surface zero
//   when in DDX, then it would probably hang and you'd have to restart your
//   machine!
//
// TBitsSurface::InvertBits()
//   This flips vertically the given surface. It locks it first, if necessary.


#ifndef __bits_h
#define __bits_h
#ifndef __DDRAW_INCLUDED__
#include "../../lib/ddraw.h"
#endif

void BitsDebug(const char *);


#define BITS_OK                0
#define BITSERR_INVALIDPARAMS  1
#define BITSERR_BADDDRAW       2
#define BITSERR_NODDRAW        3
#define BITSERR_UNSUPPORTED    4
#define BITSERR_ALREADYCREATED 5
#define BITSERR_LOCKED         6
#define BITSERR_NOTLOCKED      7
#define BITSERR_NOTCREATED     8
#define BITSERR_DDERROR        9
#define BITSERR_NOHWND         10
#define BITSERR_NOTPALETTE     11


typedef HRESULT (WINAPI *DIRECTDRAWCREATE) ( GUID FAR *lpGUID, LPDIRECTDRAW FAR *lplpDD, IUnknown FAR *pUnkOuter );

extern HINSTANCE hDDraw;
extern DIRECTDRAWCREATE pDirectDrawCreate;
extern DDCAPS DDDriverCaps;
extern DDCAPS DDHelCaps;
extern DDSURFACEDESC *DDModes;
extern unsigned int DDNumModes;

void BitsInit(HINSTANCE hInstance, BOOL trace=FALSE);
void BitsClose();
HRESULT BitsQueryDD(HWND);

typedef struct tagBitsPalette
{ WORD Version;
  WORD NumberOfEntries;
  PALETTEENTRY Entries[256];
} TBitsPalette;


class TBits;
class TBitsSurface;
class TDibPainter;

class TBitsSurface
{ public:
  TBitsSurface();
  ~TBitsSurface();
  // Some functions first
  HRESULT Lock(BOOL toread=TRUE,BOOL towrite=TRUE);
  HRESULT Unlock();
  HRESULT CopyBitsFrom(TBitsSurface &,BOOL RespectOrientation=TRUE);
  HRESULT InvertBits();
  // These first few things are all common
  union { LPDWORD lpdw; LPVOID lpv; LPBYTE lpb; } data;
  // The next few are for DIBSections
  BOOL DibPresent;
  HDC Dibhdc;
  HGDIOBJ DibhOldBitmap;
  // The next few are for DDraw
  IDirectDrawSurface *dds;
  DDSURFACEDESC ddsd; // only valid when locked
  // and internal stuff
  TBits *bits;
  BOOL islocked;
  union { LPDWORD lpdw; LPVOID lpv; LPBYTE lpb; } internaldata;
  BOOL dirtypalette; // for Dibs, we only update it's color-table when it gets to the front
};


class TDibPainter
{ public:
  TDibPainter();
  void Setup(HWND hwnd,int cx,int cy);
  void DontPaint();
  void StretchToWindow();
  void ProportionStretchToWindow();
  void StretchToRect(RECT &);
  void StretchToRect(int left,int top,int right,int bottom);
  void CenterInWindow();
  void CenterAtPoint(POINT &);
  void CenterAtPoint(int x,int y);
  void PositionAtPoint(POINT &);
  void PositionAtPoint(int x,int y);
  void PositionInRect(RECT &);
  void PositionInRect(int left,int top,int right,int bottom);
  void Paint(HDC dest,PAINTSTRUCT &,HDC src,BOOL flip);
  BOOL stretch,paint,dirty;
  RECT rc;
  HWND hwnd; int cx,cy;
  int promise; RECT promrc; POINT prompt;
};


class TBits
{ public:
  TBits();
  ~TBits();
  HRESULT Create(HWND,BOOL useddx,int NumSurfaces,unsigned int cx,unsigned int cy,unsigned int bpp, BOOL dibusefullpalette);
  HRESULT CreateCompatible(HWND,BOOL useddx,TBits &compatible,BOOL dibusefullpalette);
  HRESULT CreateDibCopy(HWND,TBitsSurface &copyfrom);
  HRESULT CreateDibResample(HWND,TBitsSurface &copyfrom,unsigned int cx,unsigned int cy,unsigned int bpp,BOOL dibusefullpalette);
  HRESULT CreateDibFromScreen(HWND,unsigned int cx=0, unsigned int cy=0);
  HRESULT CreateDibFromFile(HWND,const char *);
  HRESULT CreateDibFromResource(HWND,int);
  void CopyPaletteFrom(TBits &);
  HRESULT Reset();
  // now for some common functions
  TBitsSurface *GetSurface(int surface);
  TBitsSurface *LockSurface(int surface,BOOL toread=TRUE,BOOL towrite=TRUE);
  void UnlockSurface(TBitsSurface *bs);
  HRESULT Flip(DWORD dwFlags=0);
  HRESULT ChangePalette(BOOL lazy=TRUE); // First, set up your new palette in 'LogPal'
  // now for some responses to windows messages, required if you use DIBs
  // NB. If you did auto-subclass, then everything would be done for you.
  void WmActivateApp(WPARAM,LPARAM);
  LRESULT WmPaint(WPARAM,LPARAM);
  void Paint(HDC,PAINTSTRUCT &);
  void WmPaletteChanged(WPARAM,LPARAM);
  LRESULT WmQueryNewPalette(WPARAM,LPARAM);
  void WmEraseBkgnd(WPARAM,LPARAM);
  void TakeFullPalette();
  void RelinquishFullPalette();
  // These next few are common to both DIB and DDX
  int NumSurfaces;
  unsigned int cx,cy,bpp;
  BOOL isddx, isdib;
  TBitsSurface *surface;  // if you want more than that, you'll have to malloc the right size TBits
  TBitsPalette LogPal;    // this is a unified thing that applies to both, in 8bpp
  int orientation;        // +1 has zero at top left; -1 has it at bot left
  int numbytes, numdwords;
  // next few are for DIBSections
  HPALETTE hDibPal;
  RGBQUAD DibCols[256];
  BOOL DibUseFullPalette; // if TRUE, then reserve only two system colours; otherwise, twenty
  COLORREF OldColours[20];
  BOOL havecopiedoldcolours, haveremovedstatics;
  TDibPainter DibPainter;
  HRESULT EnableSubclass(BOOL autopaint=TRUE,HBRUSH hbrBackground=NULL);
  HRESULT EnableFullSubclass(BOOL reverse);
  HRESULT DisableSubclass();
  BOOL enablesubclass,issubclassed,autopaint,reverse,fullsubclass;
  LONG oldstyle; RECT oldsize;
  HBRUSH hbrBackground;
  void SubclassInit();
  void SubclassClose();
  WNDPROC oldwndproc;
  // next few are for DirectDraw
  IDirectDraw *dd;
  IDirectDrawPalette *ddpal;
  // and some internal data
  HWND hwnd;
  BOOL hassetpalette;
  BOOL isgettingscreen;
private:
  HRESULT Init(BOOL useddx);
  HRESULT InitDdx();
  HRESULT InitDib();
};


#define NEXTRAND(r) (1664525*r+1013904223)
#define NEXTRAND2(r) (NEXTRAND(NEXTRAND(r)))
#define NEXTRAND3(r) (NEXTRAND(NEXTRAND2(r)))
#define NEXTRAND4(r) (NEXTRAND2(NEXTRAND2(r)))
#define NEXTRAND5(r) (NEXTRAND(NEXTRAND4(r)))


#endif