#ifndef _SCRAPI_H_
#define _SCRAPI_H_

#ifndef __WINDOWS_H
#include <windows.h>
#endif


// The following constants are how the 'corner' field works.
#define action_default_char '-'
#define action_now_char 'Y'
#define action_never_char 'N'
// and they appear in the registry in the order tl, tr, br, bl


// These are help topics in the Plus! help file
#define PLUSHELP_CORNERS       3100
#define PLUSHELP_THRESHOLD     3101
#define PLUSHELP_PASSWORDDELAY 3102
#define PLUSHELP_COPYRIGHT     3103
#define PLUSHELP_PREVIEW       3104
#define PLUSHELP_MUTE          3105


typedef VOID (WINAPI *SCREENSAVERCHANGED)();
// "ScreenSaverChanged" is in SAGE.DLL. When you call it, the system agent
// reads information from the registry key
// \HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Screen Savers\Mouse Corners
// and watches for those hot corners as of immediately
typedef BOOL (WINAPI *SYSTEMAGENTDETECT)();
// "SystemAgentDetect" is in SAGE.DLL. Returns true if the system agent
// is both running and enabled.
typedef VOID (WINAPI *PWDCHANGEPASSWORD) (LPCSTR lpcRegkeyname,HWND hwnd,UINT uiReserved1,UINT uiReserved2);
// "PwdChangePassword" is in MPR.DLL, the Master Password Router
// It uses password stuff in
// \HKEY_LOCAL_MACHINE\System\CurrentControlSet\control\PwdProvider\Regkeyname
// and will pop up a dialog as child of hwnd for you to type in a new password
typedef BOOL (WINAPI *VERIFYSCREENSAVEPWD)(HWND hwnd);
// "VerifyScreenSavePwd" is in PASSWORD.CPL. Pops up a box (child of hwnd);
// return true if you got it right and false otherwise.
// It uses the password stuff referred to in
// \HKEY_LOCAL_MACHINE\System\CurrentControlSet\control\PwdProvider\SCRSAVE

#endif

